Class StackFractions


	'============================================================
	' Put your Button descriptors here
	'------------------------------------------------------------
	Private Sub Class_Initialize

		ScriptType = 	"vbs"
		ThisClassName = "StackFractions"	'(Must be the same as class statement above)
		ToolTipText = 	"Convert selected Dims to Stacked Fractions"
		ImageURL = 	"ButtonImages\Fractions.GIF"
		LinkURL =	""
	End Sub
	'------------------------------------------------------------



	'============================================================
	' Place actual script in this sub (do not rename)
	'------------------------------------------------------------

		Public Sub ExecScript
			Dim ActiveDrawing
			Set ActiveDrawing = Application.ActiveDrawing
			Dim sel, i, ttext, undorec, undotest, tgraphic
			Set sel = ActiveDrawing.Selection
			undotest = false

		        '**********************************************
		        ' Edit the 0.6 value in the next line to adjust fraction size

			const ReduceFractionFont = 0.6	'0.6 = 60% of normal size

		        '**********************************************
			
			For i = 0 to sel.count -1
		            ttext = sel(i).Properties("Info")

			    If InStr(sel(i).Type, "Dim") and left(ttext, 1) = "<" and instr(ttext, "/") Then

			        if undotest = false then
			              undotest = true
			              Set undorec = ActiveDrawing.AddUndoRecord("StackFractions")
			        end if
			        undorec.AddGraphicForModify (sel(i))

				'This is the bit that does the reformating
			
				if instr(ttext, " ") then
				        ttext = Replace(ttext, "<", "")
				        ttext = Replace(ttext, "/", "#" )
				        ttext = Replace(ttext, " ", " {\H" & trim(ReduceFractionFont) & "x;\S")
				        ttext = Replace(ttext, ">", ";} " & mid(sel(i).Properties("$DIMPOST"),3) )
				        sel(i).Properties("Info") = ttext
				        sel(i).Update
				else
				        ttext = Replace(ttext, "<",  "{\H" & trim(ReduceFractionFont) & "x;\S")
				        ttext = Replace(ttext, "/", "#" )
				        ttext = Replace(ttext, ">", ";} " & mid(sel(i).Properties("$DIMPOST"),3) )
					'msgbox ttext
				        sel(i).Properties("Info") = ttext
				        sel(i).Update

					'msgbox ttext

				end if

			
	        
			    End If
			Next

			if undotest = true then undorec.close

			activedrawing.activeview.refresh
       		End Sub

	'------------------------------------------------------------



	'============================================================
	' This parts same for all classes. Do not change !!!!
	'------------------------------------------------------------

		public ThisClassName
		public ToolTipText
		public ImageURL
		public LinkURL
		public ScriptType
		

	'------------------------------------------------------------



End Class
