option explicit
class clsExportFilterArgs
	public UserAction
	public FName, Filter 
end class



Class ExportFilter

	public ExportFilterArgs	' NOTE!!!! Initialised in class_initialise

	'============================================================
	' Put your Button descriptors here
	'------------------------------------------------------------
	Private Sub Class_Initialize

		ScriptType = 	"vbs"
		ThisClassName = "ExportFilter"	'(Must be the same as class statement above)
		ToolTipText = 	"Collection on Import Filters"
		ImageURL = 	"ButtonImages\ExportFilter.GIF"
		LinkURL =	""	'"BC_ExportFilter.html"
		set ExportFilterArgs = new clsExportFilterArgs
			ExportFilterArgs.FName=""
			ExportFilterArgs.Filter="SelectionVertices"
	End Sub
	'------------------------------------------------------------



	'============================================================
	' Place actual script in this sub (do not rename)
	'------------------------------------------------------------

		Public Sub ExecScript
		
			showmodaldialog "BC_ExportFilter.html", ExportFilterArgs, "dialogWidth:300px; dialogHeight:450px"
			
			if ExportFilterArgs.UserAction="OK" then
				
				Dim ActiveDrawing, UndoRec
				Set ActiveDrawing = Application.ActiveDrawing
		
				dim WshShell, fso, tfile, fName, ts, msgout
				Set WshShell = CreateObject("WScript.Shell")
				Set fso = CreateObject("Scripting.FileSystemObject")
				
				msgout = vbOK
				if fso.FileExists(ExportFilterArgs.FName) then
					msgout=msgbox ("File already exists, replace existing file?",vbOKCancel)
				end if
				if msgout = vbOK then
					set ts = fso.createtextfile(ExportFilterArgs.FName, true)
					If ExportFilterArgs.Filter="SelectionVertices" then
						ExportSelectionVertices ts, ActiveDrawing
					End If
					ts.close
				end if

				ActiveDrawing.ActiveView.Refresh
			end if

		End Sub

	'------------------------------------------------------------



	'============================================================
	' This parts same for all classes. Do not change !!!!
	'------------------------------------------------------------

		public ThisClassName
		public ToolTipText
		public ImageURL
		public LinkURL
		public ScriptType
		

	'------------------------------------------------------------

	Sub ExportSelectionVertices(ts, ActiveDrawing) 
		on error resume next
        Dim t, x0, y0, z0, x1, y1, z1, n, r0, gr, tsel, i, j
        Set tsel = ActiveDrawing.Selection

		if tsel.count=0 then 
			msgbox "No selected graphics, export aborted"
		end if
		for i = 0 to tsel.count-1
			set gr= tsel.item(i)
			ts.writeline gr.id & ", " & gr.Properties("Info") & ", , ,"
			for j = 0 to gr.vertices.count-1
				ts.writeline ", , " & gr.vertices(j).X & ", " & gr.vertices(j).Y & ", " & gr.vertices(j).Z
			next
			
			set gr = Nothing
		next
		
	End Sub



End Class
